%define name    rssowl
%define version 1.2.3
%define release 1%{?dist}

Name:           %name
Summary:        An RSS, RDF and Atom Newsreader
Version:        %version
Release:        %release
License:        CPL
Group:          Applications/Internet
URL:            http://www.rssowl.org
# This is identical to the upstream tar ball, except that all binary
# code jar files have been removed.
Source0:        rssowl_1_2_3_src-CLEAN.tar.gz
Source1:        %{name}.script
Source2:        %{name}.desktop
Patch0:         %{name}-use-jce.patch
Patch1:         %{name}-build0.patch
Patch3:         %{name}-build1.patch
Patch5:         %{name}-browser.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       jre >= 1.4.2-
BuildRequires:  java-sdk >= 1.4.2
BuildRequires:  ImageMagick
BuildRequires:  ant, itext, jdom, jakarta-commons-codec, jakarta-commons-httpclient, eclipse-rcp >= 3.2.1
BuildRequires:  libgconf-java
BuildRequires:  xerces-j2, jpackage-utils >= 1.5
BuildRequires:	dos2unix
BuildRequires:    java-gcj-compat-devel >= 1.0.31
Requires(post):   java-gcj-compat >= 1.0.31
Requires(postun): java-gcj-compat >= 1.0.31
Requires:       itext, jdom, jakarta-commons-codec, jakarta-commons-httpclient, eclipse-rcp >= 3.2.1
Requires:       xerces-j2, libgconf-java
Requires:       firefox
BuildRequires:    desktop-file-utils
Requires(post):   desktop-file-utils
Requires(postun): desktop-file-utils

%description
RSSOwl is a RSS / RDF / Atom Newsreader written in Java using SWT as
fast graphic library. Read News in a tabfolder, save favorites in
categories, Export to PDF / RTF / HTML / OPML, Import Feeds from OPML,
perform fulltext-search, use the integrated browser.

%description -l de
RSSOwl ist ein RSS / RDF / Atom Newsreader in Java mit SWT als
GUI-Bibliothek. Einige der Features sind Export von Nachrichten nach
PDF / RTF / HTML, Import / Export mit OPML, Volltextsuche und der
integrierte Browser.

%prep
%setup -q -n rssowl_1_2_3_src
%patch0 -p0
%patch1 -p0
%patch3 -p0
%patch5 -p0
# This package doesn't contain any MPL licensed code.
rm doc/mpl-v11.txt

%build
build-jar-repository -p lib jdom itext jakarta-commons-codec jakarta-commons-httpclient glib0.2 gconf2.12 gtk2.8 xerces-j2
ln -s %{_datadir}/eclipse/plugins/org.eclipse.jface_3.2.1.M20060908-1000.jar lib
ln -s %{_libdir}/eclipse/swt-gtk-3.2.jar lib
cd src
ant deploy_linux

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_javadir}
install -m 644 rssowl.jar $RPM_BUILD_ROOT%{_javadir}/rssowl.jar

# FIXME:  do these really need to be converted?  Couldn't they be shipped as PNGs?
convert img/16x16.gif img/16x16.png
convert img/24x24.gif img/24x24.png
convert img/32x32.gif img/32x32.png
# FIXME:  this is ugly :)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/24x24/apps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps
install -m 644 img/32x32.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/rssowl.png
install -m 644 img/16x16.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/rssowl.png
install -m 644 img/24x24.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/24x24/apps/rssowl.png
install -m 644 img/32x32.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/rssowl.png

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install --vendor fedora 			\
	--dir ${RPM_BUILD_ROOT}%{_datadir}/applications	\
	--add-category X-Fedora				\
	%{SOURCE2}

mkdir -p $RPM_BUILD_ROOT/%{_bindir}
cp %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}
sed --in-place "s:/usr/lib:%{_libdir}:" \
  $RPM_BUILD_ROOT%{_bindir}/%{name}
sed --in-place "s:/usr/share:%{_datadir}:" \
  $RPM_BUILD_ROOT%{_bindir}/%{name}
chmod 755 $RPM_BUILD_ROOT/%{_bindir}/%{name}

dos2unix doc/tutorial/en/*.html
dos2unix doc/tutorial/en/styles/*
dos2unix doc/*.{xml,html,txt,template}

aot-compile-rpm

%post 
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
update-desktop-database %{_datadir}/applications
# update icon themes
touch %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi

%postun 
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
update-desktop-database %{_datadir}/applications
# update icon themes
touch %{_datadir}/icons/hicolor
if [ -x /usr/bin/gtk-update-icon-cache ]; then
  /usr/bin/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc doc/*
%{_javadir}/*
%{_datadir}/applications/*
%{_datadir}/pixmaps/*
%{_datadir}/icons/*
%{_bindir}/%{name}
%{_libdir}/gcj/%{name}

%changelog
* Wed Nov 29 2006 Andrew Overholt <overholt@redhat.com> 1.2.3-1
- 1.2.3.
- Guard against rebuild-gcj-db presence and installation ordering.
- Symlink to swt in %%{_libdir} where it now resides.
- Use %%{_datadir}/eclipse instead of /usr/share/eclipse.
- Remove symlink to org.eclipse.ui.forms - no longer needed.
- Remove requirement on eclipse-platform - no longer needed.
- Add xerces-j2 requirement.
- Update build1 patch.
- Remove ui.forms from rssowl.script.

* Mon Nov 06 2006 Andrew Overholt <overholt@redhat.com> 1.2.2-7
- Use SWT in new %%{_libdir} location.

* Wed Oct  4 2006 Anthony Green <green@redhat.com> - 1.2.2-6
- Fix build classpath.

* Wed Oct  4 2006 Anthony Green <green@redhat.com> - 1.2.2-5
- Update rssowl.script for Eclipse SDK 3.2.1.
- Tweak Requires and BuildRequires for eclipse-platform.

* Tue Sep 19 2006 Anthony Green <green@redhat.com> - 1.2.2-4
- Fix release tag.

* Mon Sep 18 2006 Anthony Green <green@redhat.com> - 1.2.2-3.1
- Rebuild.

* Sat Sep  1 2006 Anthony Green <green@redhat.com> - 1.2.2-3
- Increment release tag to fix upgrade path from FC5 to FC6.

* Thu Aug 31 2006 Anthony Green <green@redhat.com> - 1.2.2-1
- Update sources. 

* Fri Aug  4 2006 Anthony Green <green@redhat.com> - 1.2.1-4
- Modify startup script to use firefox's libxpcom.so.
- Require firefox.

* Sun Jul 30 2006 Anthony Green <green@redhat.com> - 1.2.1-3
- Tweak jar references for FC6.
- Use -p option on build-jar-repository to work around ecj misfeature.
- Fix rssowl script (thanks aph!).

* Mon May  8 2006 Anthony Green <green@redhat.com> - 1.2.1-2
- Fix bugzilla #191044 - postinstall scriptlet typo error.  
  Thanks to Chien-Chung Yeh for the fix. 

* Sat May  6 2006 Anthony Green <green@redhat.com> - 1.2.1-1
- Update sources.

* Fri Mar 10 2006 Anthony Green <green@redhat.com> - 1.2-13
- Fix script goof.

* Thu Mar  9 2006 Anthony Green <green@redhat.com> - 1.2-11
- Rebuild with new compiler.

* Tue Feb  7 2006 Anthony Green <green@redhat.com> - 1.2-10
- Fix swt jar reference in build-jar-repository.

* Tue Feb  7 2006 Anthony Green <green@redhat.com> - 1.2-9
- Update eclipse-platform requirement in spec file and eclipse swt and 
  runtime references in rssowl.script.
- Install .desktop file propertly.
- Run update-desktop-database and gtk-update-icon-cache in post and postun.
- Add desktop-file-utils dependencies.
- Tweak description.

* Mon Jan 16 2006 Anthony Green <green@redhat.com> 1.2-7
- Word-wrapped descriptions.
- Set Group to Applications/Internet.
- Cleaned up changelog changelog entries.
- Improved Summary.
- Converted text files to "unix" with dos2unix.
- Fixed documentation and jar file locations.
- Update rssowl accordingly.

* Mon Jan 16 2006 Anthony Green <green@redhat.com> 1.2-6
- Add Requires for libgconf-java (thanks Andrew Overholt!)

* Fri Jan 13 2006 Anthony Green <green@redhat.com> 1.2-5
- Remove debugging patches.
- Use java-gnome API to find preferred browser.

* Thu Jan  5 2006 Anthony Green <green@redhat.com> 1.2-4
- Remove MPL license text (this was for itext.jar, which is packaged
  separately now.

* Wed Jan  4 2006 Anthony Green <green@redhat.com> 1.2-2
- Use JessieX509 instead of SunX509.

* Wed Jan  4 2006 Anthony Green <green@redhat.com> 1.2-1
- Upgrade to RSSOwl 1.2.
- Many new related patches.
- Remove utf8 patch.
- Use clean sources (no precompiled .class files in jars)
- Build as native code.
- Merge overholt's spec file with Kay's.

* Wed Nov 09 2005 Kay Patzwald <kay_patzwald@users.sourceforge.net>
- change buildrequires to java-sdk >= 1.4.2 and change the startscript to rssowl.sh

* Wed Jul 27 2005 Andrew Overholt <overholt@redhat.com> 1.1.3-0.2
- Include rssowl.script and rssowl.desktop as separate files.
- Use Robin Green's work in /usr/bin/eclipse to make internal browser work.
- Add native compilation (but leave unused until we get all dependencies sorted
  out).

* Mon Jul 25 2005 Andrew Overholt <overholt@redhat.com> 1.1.3-0.1
- New upstream version.
- Update build patch and use new deploy task.

* Wed Jul 06 2005 Andrew Overholt <overholt@redhat.com> 1.1.2-0.2
- First go at some cleanups.
- Patch around a libgcj issue with "utf8" vs. "utf-8".

* Sun Jun 12 2005 Kay Patzwald <kay_patzwald@users.sourceforge.net>
- change the menu-category from usenet-news to rss-news
* Wed May 25 2005 Kay Patzwald <kay_patzwald@users.sourceforge.net>
- Little modifications at the startscript, rssowl accepts shell-arguments
* Sun Mar 22 2005 Kay Patzwald <kay_patzwald@users.sourceforge.net>
- Add "AutoReqProv: no" and change jdk-requirements
* Sun Mar 20 2005 Kay Patzwald <kay_patzwald@users.sourceforge.net>
- new jdk-requirements
* Wed Mar 07 2005 Kay Patzwald <kay_patzwald@users.sourceforge.net>
- change the menu-category of rssowl from network to news
* Wed Aug 18 2004 Kay Patzwald <admiral_kay@users.sourceforge.net>
- swt*.jars are not required in the bin-rpm
* Wed Aug 18 2004 Kay Patzwald <admiral_kay@users.sourceforge.net>
- libs will copied to the rssowl-dir now
* Tue Aug 10 2004 Kay Patzwald <admiral_kay@users.sourceforge.net>
- some little changes
* Sat Aug 07 2004 Manfred Tremmel <Manfred.Tremmel@iiv.de>
- some rework
* Tue Aug 03 2004 Kay Patzwald <admiral_kay@users.sourceforge.net>
- first release
